<?php

#    header ('Content-type: text/plain');
    header ('Content-type: text/xml');

    include "tag.php";
    include "def.php";
    include "db.php";
    include "check.php";
    

    function stopSession ($mac, $id, $ses_id)
    {
	$mac_orig = $mac;
	
	if (($mac = checkMac ($mac)) == -1)
        {
            return error ("Error: Wrong MAC=" . $mac_orig, "recorder");
        }

        $query = "SELECT * FROM cameras WHERE mac='" . $mac . "' AND del=0";

        $query_resp     = @mysql_query ($query, $id);
        $num            = @mysql_numrows ($query_resp);

        if ($num < 1)
        {
	    return error ("Error: Camera with MAC='" . $mac_orig . "' is not found", "recorder");
        }
	
	$query = "SELECT * FROM sessions WHERE mac='" . $mac . "' AND id='" . $ses_id . "' AND del=0";

        $query_resp     = @mysql_query ($query, $id);
        $num            = @mysql_numrows ($query_resp);

        if ($num < 1)
        {
	    return error ("Error: Database has no info about the session with id='" . $ses_id . "' (camera MAC='". $mac_orig . "')", "recorder");
        }
	
	$stop_stream = @mysql_result ($query_resp, $i, "stop_stream");
	if ($stop_stream != 0)
	{
	    return error ("Error: This session seems to be already stopped. Reason: stop_stream field already set as " . $stop_stream, "recorder");
	}
	
	$pid = @mysql_result ($query_resp, $i, "strm_pid");
	if (!posix_kill ($pid, 1))
	{
// just do something or there is no way out if the DB shows the session is closed and the process is dead.
//	    return error ("Error: Can't send a signal to pid='".$pid."' Session may be already stopped.", "recorder");
	}
	
	$stop_stream	= gettimeofday();
	$stop_stream	= $stop_stream["sec"];
	
	$log_file = @mysql_result ($query_resp, $i, "log_file");
	$status   = shell_exec("cat $log_file | tr -s '\r' '\n' | tail -n 2 | tr -s '\n' '\t' ");	

	$query  = "UPDATE sessions SET stop_stream='" . $stop_stream . "', status='" . $status . "' WHERE mac='" . $mac ;
	$query .= "' AND id='" . $ses_id . "' AND del=0";
        $query_resp     = @mysql_query ($query, $id);
	
	$ret = formClosedTag ("OK", "stop", "") . "\n";	
	$ret = formClosedTag ($ret, "recorder", "\n");	
	
	unlink ($log_file);
		
	return $ret;
    }


    function startSession ($mac, $id, $strm_ip, $strm_port, $fps, $width, $height, $max_file_size, $max_frame_size, $tmp)
    {
        global $DOCUMENT_ROOT;
	$mac_orig = $mac;
	
	if (($mac = checkMac ($mac)) == -1)
        {
            return error ("Error: Wrong MAC=" . $mac_orig, "recorder");
        }

        $query = "SELECT * FROM cameras WHERE mac='" . $mac . "' AND del=0";

        $query_resp     = mysql_query ($query, $id);
        $num            = mysql_numrows ($query_resp);

        if ($num < 1)
        {
	    return error ("Error: Camera with MAC='" . $mac . "' is not found", "recorder");
        }

	$ip1   = @mysql_result ($query_resp, $i, "ip1");
	$ip2   = @mysql_result ($query_resp, $i, "ip2");
	$place = @mysql_result ($query_resp, $i, "place");
	
	if (! $strm_ip)
	{
	    return error ("Error: Wrong strm_ip=" . $strm_ip, "recorder");
	}
	
	if (! $strm_port)
	{
	    return error ("Error: Wrong strm_port=" . $strm_port, "recorder");
	}
	
	if (! $fps)
	{
	    return error ("Error: Wrong fps=" . $fps, "recorder");
	}
	
// Insert check value code here in the future!!!

	$start 		= gettimeofday();
	$start_sec	= $start["sec"];
	$start_usec	= $start["usec"];
	$start_stream 	= $start_sec;
	$stop_stream	= 0;
	
	$log_file	= log_dir . "/" . $mac . "_" . $start_sec . "_" . $start_usec . ".log" ;
//	$cmd		= "nohup " . eo ." -o -a " . $strm_ip . " -p " . $strm_port . " -f " . $fps . " > /dev/null 2>" . $log_file . " & echo $! ";
	$cmd		= "nohup " . eo ." -o -a " . $strm_ip . " -p " . $strm_port . " -f " . $fps ;

	if ($skip) $cmd 		.= " -k " . $skip;
	if ($max_file_size) $cmd 	.= " -m " . $max_file_size;
	if ($max_frame_size) $cmd	.= " -F " . $max_frame_size;
        $cmd		.= " > /dev/null 2>" . $log_file . " & echo $! ";
	
//	$ses_data_dir 	= work_dir;
   $ses_data_dir=$DOCUMENT_ROOT.url_base; // this will work if absolute path is changed (i.e. on different versions of Live DVD same drive was called sda2 and uba2)
	if (! file_exists ("$ses_data_dir"))
	{
	    if (! @mkdir ("$ses_data_dir"))
	    {
		return error ("Error: Can't create directory '" . $ses_data_dir . "'!"."document_ROOT=".$DOCUMENT_ROOT, "recorder");
	    }
	}

	
	$ses_data_dir 	.= "/camera_" . $mac;
	if (! file_exists ("$ses_data_dir"))
	{
	    if (! @mkdir ("$ses_data_dir"))
	    {
		return error ("Error: Can't create directory '" . $ses_data_dir . "'!", "recorder");
	    }
	}

	$ses_data_dir 	.= "/" . $start_stream;
	if (! file_exists ("$ses_data_dir"))
	{
	    if (! @mkdir ("$ses_data_dir"))
	    {
		return error ("Error: Can't create directory '" . $ses_data_dir . "'!", "recorder");
	    }
	}
	
	if (! @chdir ("$ses_data_dir"))
	{
	    return error ("Error: Can't cdir to directory '" . $ses_data_dir . "'!", "recorder");
	}
//   return error ("--cmd=".$cmd."max_file_size=".$max_file_size, "recorder");

	escapeshellcmd ($cmd);
	$pid = trim (shell_exec ($cmd));

	$query  = "INSERT INTO sessions ";
	$query .= " (mac, strm_pid, ip1, ip2, place, start_stream, fps, skip, max_file_size, max_frame_size, strm_ip, strm_port, width, height, tmp, log_file, del)"; 
	$query .= " VALUES ('$mac', '$pid','$ip1', '$ip2', '$place', '$start_stream', '$fps', '$skip', '$max_file_size', '$max_frame_size', '$strm_ip', '$strm_port', '$width', '$height', '$tmp', '$log_file', '0')";
        $query_resp     = mysql_query ($query, $id);

	$ret = mysql_insert_id ($id);
	$ret = formClosedTag ($ret, "id", "") . "\n";	
	$ret = formClosedTag ($ret, "session", "\n") . "\n";	
	$ret = formClosedTag ($ret, "recorder", "\n");	
    
        return $ret;
    }


    
    function printFileNameList ($mac, $start_stream)
    {
	$ses_data_dir 	= work_dir . "/camera_" . $mac . "/" . $start_stream;
	
	
	if (! @chdir ("$ses_data_dir"))
	{
	    return error ("Error: Can't cdir to directory '" . $ses_data_dir . "'!", "files") . "\n";
	}
	
	
	if ($handle = opendir($ses_data_dir)) 
	{
	    while (false !== ($file = readdir($handle))) 
	    {
		if (! is_dir ($file))
		{
		    $url   = url_base . "/camera_" . $mac ."/" . $start_stream . "/" . $file;
		    $size  = stat ($file);
		    $size  = $size[size];
		    $ret_  = '';
		    $ret_ .= formClosedTag ($file, "name", "") . "\n";
		    $ret_ .= formClosedTag ($size, "size", "") . "\n";
		    $ret_ .= formClosedTag ($url, "url", "") . "\n";
		    $ret  .= formClosedTag ($ret_, "file", "\n") . "\n";
		}
	    }

	    closedir($handle);
	}	
	
	$ret = formClosedTag ($ret, "files", "\n") . "\n";
	
	return $ret;
    }


    function listSession ($mac, $id, $ses_id, $min_start_time, $max_start_time, $next_start_time, $prev_start_time, $print_serv_info)
    {
	$mac_orig = $mac;
# Insert here check values function!!!    

	if (!$mac)
	{
	    return error ("Error: Wrong MAC='" . $mac_orig . "'", "recorder");
	}

	if (($mac = checkMac ($mac)) == -1)
        {
            return error ("Error: Wrong MAC='" . $mac_orig . "'", "recorder");
        }
	
	
	$query_mac	= " mac='" . $mac . "' AND ";
	
	if ($ses_id)
	{
	    $query_id	= " id='" . $ses_id . "' AND ";
	}
	
	if ($min_start_time)
	{
	    if ($next_start_time || $prev_start_time)
	    {
		return error ("Error: Can not process 'next_start_time' or 'prev_start_time' with 'min_start_time' in the same request!", "recorder");
	    }
	    
	    $query_min = " start_stream>='" . $min_start_time . "' AND ";
	}
	
	if ($max_start_time)
	{
	    if ($next_start_time || $prev_start_time)
	    {
		return error ("Error: Can not process 'next_start_time' or 'prev_start_time' with 'max_start_time' in the same request!", "recorder");
	    }
	    
	    $query_max = " start_stream<='" . $max_start_time . "' AND ";
	}
	
	
	if ($next_start_time)
	{
	    if ($prev_start_time)
	    {
		return error ("Error: Can not process  'next_start_time' with 'prev_start_time' in the same request!", "recorder");
	    }
	    
	    $query_next  = " start_stream>'" . $next_start_time . "' AND ";
	    $query_limit = " LIMIT 1 ";
	}
	
	if ($prev_start_time)
	{
	    if ($next_start_time)
	    {
		return error ("Error: Can not process 'next_start_time' with 'prev_start_time' in the same request!", "recorder");
	    }
	    
	    $query_prev  = " start_stream<'" . $prev_start_time . "' AND ";
	    $query_limit = " LIMIT 1 ";
	    $query_order = " DESC ";
	}
	
	$query  = "SELECT * FROM sessions WHERE ";
	$query .= $query_mac . $query_id . $query_min . $query_max . $query_next . $query_prev;
	$query .= " del=0 ORDER BY start_stream " . $query_order .   $query_limit;

        $query_resp     = mysql_query ($query, $id);
        $num            = @mysql_numrows ($query_resp);

        if ($num < 1)
        {
	    return error ("Error: Database does not have any items satisfying the query!", "recorder");
        }
	$ret = '';
	$i   = 0;
	while ($i < $num)
	{
	    $ret_  = '';
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "id"), "id", "") . "\n";
	    if ($print_serv_info == 1)
	    {
		$ret_ .= formClosedTag (mysql_result ($query_resp, $i, "strm_pid"), "pid", "") . "\n";
		$mac_  = getDottedMAC (mysql_result ($query_resp, $i, "mac"));
		$ret_ .= formClosedTag ($mac_, "camera_mac", "") . "\n";
	    }
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "ip1"), "ip1", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "ip2"), "ip2", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "place"), "place", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "start_stream"), "start_stream", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "stop_stream"), "stop_stream", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "fps"), "fps", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "width"), "width", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "height"), "height", "") . "\n";
	    $ret_ .= formClosedTag (mysql_result ($query_resp, $i, "tmp"), "tmp", "") . "\n";
	    
	    $ret_ .= printFileNameList (mysql_result ($query_resp, $i, "mac"), mysql_result ($query_resp, $i, "start_stream"));
	    
	    $status = mysql_result ($query_resp, $i, "status");
	    if (!$status) 
	    {
		$log_file = @mysql_result ($query_resp, $i, "log_file");
		$status   = shell_exec("cat $log_file | tr -s '\r' '\n' | tail -n 2 | tr -s '\n' '\t' ");	
	    }
	    $ret_ .= formClosedTag ($status, "status", "") . "\n";
	    
	    if ($print_serv_info == 1)
	    {
		$ret_ .= formClosedTag (mysql_result ($query_resp, $i, "skip"), "skip", "") . "\n";
		$ret_ .= formClosedTag (mysql_result ($query_resp, $i, "max_file_size"), "max_file_size", "") . "\n";
		$ret_ .= formClosedTag (mysql_result ($query_resp, $i, "max_frame_size"), "max_frame_size", "") . "\n";
		$ret_ .= formClosedTag (mysql_result ($query_resp, $i, "strm_ip"), "strm_ip", "") . "\n";
		$ret_ .= formClosedTag (mysql_result ($query_resp, $i, "strm_port"), "strm_port", "") . "\n";
	    }
	    
	    $ret_  = formClosedTag ($ret_, "session", "\n") . "\n";
	    $ret  .= $ret_;
	    $i++;
	}
	
	$ret = formClosedTag ($ret, "recorder", "\n") . "\n";
	return $ret;
    }




//Entry point
    
    switch ($_GET[cmd])
    {
        case "start":
        case "stop":
        case "list":
            break;
        default :
            echo error ("Error: Unknown command '" . $_GET[cmd] . "' ", "recorder");
            return 0;
            break;
    }

    $id = connectToServer (server, user, password);
    if (!$id)
    {
        echo error ("Error: " . mysql_error(), "recorder");
        return 0;
    }

    if (!openDB (database, $id))
    {
        echo error ("Error: " . mysql_error($id), "recorder");
        closeDB ($id);
        return 0;
    }

    switch ($_GET[cmd])
    {
        case "list":
	
            $ret = listSession ($_GET[mac], $id, $_GET[ses_id], $_GET[min_start_time], $_GET[max_start_time], $_GET[next_start_time], $_GET[prev_start_time], $_GET[print_serv_info]);
            break;
        case "start":
            $ret = startSession ($_GET[mac], $id, $_GET[strm_ip], $_GET[strm_port], $_GET[fps], $_GET[width], $_GET[height], $_GET[max_file_size], $_GET[max_frame_size], $_GET[tmp]);
            break;
        case "stop":
            $ret = stopSession ($_GET[mac], $id, $_GET[ses_id]);
            break;
        default :
            $ret = error ("Error: Unknown command \"$_GET[cmd]\"", "recorder");
            break;
    }

    closeDB ($id);

    echo $ret

?>

