<?php
// XML LOADING
require_once('xml_simple.php');
function parse_array($element) 
{
	global $logdata, $logindex;
	foreach ($element as $header => $value) 
	{
		if (is_array($value)) 
		{
			parse_array($value);
			$logindex++;
		} else 
		{
			$logdata[$logindex][$header] = $value;
		}
	}
}
	
$parser =& new xml_simple('UTF-8');
$def_file = "app-bar/apps.xml";
$fh = fopen($def_file, r);
$xmldata = fread($fh, filesize($def_file));
$request = $parser->parse($xmldata);

// catch errors
$error_code = 0;
if (!$request) {
	$error_code = 1;
	echo("XML error: ".$parser->error);
}

$logdata = array();
$logindex = 0;
parse_array($parser->tree);

echo "<div id=\"logo\"></div>\n";
echo "<div id=\"logotext\"><a href=\"index.php\">Elphel</a></div>\n";
echo "<div id=\"app-bar\">\n";

// TOP BAR
echo "<ul>";
for ($i = 0; $i < sizeof($logdata); $i++)
{
	if ($logdata[$i]['category'] == "main")
	{
		echo "<li>";
		if($logdata[$i]['target'] == "")
		{
			echo "<a href=\"index.php?site=".$logdata[$i]['link']."\"";
		
			if ($site == $logdata[$i]['link'])	
				 echo "class=\"name current_site\"";
			else
				echo "class=\"name\"";
		
			echo ">".$logdata[$i]['name']."</a>";
			echo "</li>\n";
		}
		// open in new window like camvc or camvc2
		if($logdata[$i]['target'] == "newwindow")
		{
			echo "<a href=\"#\"";
			echo  " onclick=\"opennewwindow('".$logdata[$i]['link']."', '".$logdata[$i]['codename']."')\" ";
		
			if ($site == $logdata[$i]['link'])	
				 echo "class='name current_site'";
			else
				echo "class='name'";
		
			echo ">".$logdata[$i]['name']."</a>";
			echo "</li>\n";
		}
	}
}
echo "</ul>\n";

echo "<a id=\"moretoogle\" href=\"#\" onclick=\"moretoogle();\">More ▼</a>\n";

// FULL SCREEN LIST
echo "<br /><div id=\"category_main\"><h2>Main Applications</h2>\n";
for ($i = 0; $i < sizeof($logdata); $i++)
{
	if ($logdata[$i]['category'] == "main")
	{
		if($logdata[$i]['target'] == "")
			echo "<a href=\"index.php?site=".$logdata[$i]['link']."\" target=\"".$logdata[$i]['target']."\" class=\"name\">".$logdata[$i]['name']."</a><br />\n";
		
		if($logdata[$i]['target'] == "newwindow")
		{
			echo "<a href=\"#\"";
			echo  " onclick=\"opennewwindow('".$logdata[$i]['link']."', '".$logdata[$i]['codename']."')\" ";
		
			if ($site == $logdata[$i]['link'])	
				 echo "class='name current_site'";
			else
				echo "class='name'";
		
			echo ">".$logdata[$i]['name']."</a>";
			echo "<br />\n";
		}
		
		echo "<span class=\"codename\">codename: ".$logdata[$i]['codename']."</span><br />\n";
		echo "<span class=\"desc\">".$logdata[$i]['description']."</span><br /><br />\n";
	}
}
echo "</div>";
// BETA APPS
echo "<br /><div id=\"category_beta\"><h2>Beta Applications (experimental / still not bug free )</h2>\n";
for ($i = 0; $i < sizeof($logdata); $i++)
{
	if ($logdata[$i]['category'] == "beta")
	{
		if($logdata[$i]['target'] == "")
			echo "<a href=\"index.php?site=".$logdata[$i]['link']."\" class=\"name\">".$logdata[$i]['name']."</a><br />\n";
		
		if($logdata[$i]['target'] == "newwindow")
		{
			echo "<a href=\"#\"";
			echo  " onclick=\"opennewwindow('".$logdata[$i]['link']."', '".$logdata[$i]['codename']."')\" ";
		
			if ($site == $logdata[$i]['link'])	
				 echo "class='name current_site'";
			else
				echo "class='name'";
		
			echo ">".$logdata[$i]['name']."</a>";
			echo "<br />\n";
		}
		
		echo "<span class=\"codename\">codename: ".$logdata[$i]['codename']."</span><br />\n";
		echo "<span class=\"desc\">".$logdata[$i]['description']."</span><br /><br />\n";
	}
}
echo "</div>";

// Advanced Examples
echo "<br /><div id=\"category_advanced\"><h2>Advanced Software Examples</h2>\n";
for ($i = 0; $i < sizeof($logdata); $i++)
{
	if ($logdata[$i]['category'] == "advanced_examples")
	{
		if($logdata[$i]['target'] == "")
			echo "<a href=\"index.php?site=".$logdata[$i]['link']."\" class=\"name\">".$logdata[$i]['name']."</a><br />\n";
		
		if($logdata[$i]['target'] == "newwindow")
		{
			echo "<a href=\"#\"";
			echo  " onclick=\"opennewwindow('".$logdata[$i]['link']."', '".$logdata[$i]['codename']."')\" ";
		
			if ($site == $logdata[$i]['link'])	
				 echo "class='name current_site'";
			else
				echo "class='name'";
		
			echo ">".$logdata[$i]['name']."</a>";
			echo "<br />\n";
		}
		
		echo "<span class=\"codename\">codename: ".$logdata[$i]['codename']."</span><br />\n";
		echo "<span class=\"desc\">".$logdata[$i]['description']."</span><br /><br />\n";
	}
}
echo "</div>";

// Camera Info
echo "<div id=\"camera_info\">\n";
echo "<div id=\"camera_info_header\">camera info</div><br />";

echo "<table cellspacing=\"3px\">";
exec("/bin/date", $arr1);
echo "<tr><td align=\"right\">Camera Time:</td><td>".implode($arr1)."</td></tr>";

exec('cat /etc/issue', $arr2);
echo "<tr><td align=\"right\">Camera / Firmware Version:</td><td>".$arr2[1]."</td></tr>"; 

$s = exec("/bin/bootblocktool -x SERNO");
echo "<tr><td align=\"right\">Camera Serial Number:</td><td>".substr($s,0,2).":".substr($s,2,2).":".substr($s,4,2).":".substr($s,6,2).":".substr($s,8,2).":".substr($s,10,2)."</td></tr>";

echo "</table>";

echo "</div>";


// close app bar div
echo "</div>\n";

?>
