/*****************************************************************************
*!
*! FILE NAME  : mtd-compat.c
*!
*! DESCRIPTION: Compatibility functions etc for linux mtd in 
*!              nandboot environment.
*!
*! ---------------------------------------------------------------------------
*! (C) Copyright 2006-2007, Axis Communications AB, LUND, SWEDEN
*!
*! This program is free software; you can redistribute it and/or modify
*! it under the terms of the GNU General Public License as published by
*! the Free Software Foundation; either version 2 of the License, or
*! (at your option) any later version.
*!
*! This program is distributed in the hope that it will be useful,
*! but WITHOUT ANY WARRANTY; without even the implied warranty of
*! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*! GNU General Public License for more details.
*!
*! You should have received a copy of the GNU General Public License
*! along with this program; if not, write to the Free Software
*! Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*!
*!***************************************************************************/

#include <linux/types.h>
#include "mtd.h"

int add_mtd_device(struct mtd_info *mtd) { return 0; }
int del_mtd_device (struct mtd_info *mtd) { return 0; }

struct mtd_info *get_mtd_device(struct mtd_info *mtd, int num) { return 0; }

void put_mtd_device(struct mtd_info *mtd) {}

void register_mtd_user (struct mtd_notifier *new) {}
int unregister_mtd_user (struct mtd_notifier *old) { return 0; }

//int nand_update_bbt (struct mtd_info *mtd, loff_t offs) { BUG(); }
//int nand_default_bbt (struct mtd_info *mtd) { BUG(); }
//int nand_isbad_bbt (struct mtd_info *mtd, loff_t offs, int allowbbt) { BUG(); }

void simple_printk(const char *str) { puts(str); putc('\r'); }

/***************************** END OF FILE *****************************/
